package com.zilber.boot.activiti.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotNull;
import java.util.Map;

@Getter
@Setter
@ApiModel("完成流程任务")
public class TaskCompleteDTO {

    @NotNull(message = "请选择审批结果")
    @ApiModelProperty("审批状态：1-通过 0-拒绝")
    private Integer status;

    @Length(max = 512)
    @ApiModelProperty("意见")
    private String remark;

    @ApiModelProperty(value = "流程变量")
    private Map<String, Object> variables;

    @ApiModelProperty("用户")
    private String userCode;
}
