package com.zilber.boot.activiti.vo;


import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import org.activiti.engine.history.HistoricTaskInstance;
import org.springframework.beans.BeanUtils;

import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Getter
@Setter
@ApiModel("历史任务")
public class HistoricTaskVO {

    @ApiModelProperty("任务ID")
    private String taskId;

    @ApiModelProperty("任务名称")
    private String taskName;

    @ApiModelProperty("任务描述")
    private String taskDescription;

    @ApiModelProperty("任务定义Key")
    private String taskDefinitionKey;

    @ApiModelProperty("执行人")
    private String assignee;

    @ApiModelProperty("任务开始时间")
    private Date startTime;

    @ApiModelProperty("任务结束时间")
    private Date endTime;

    @ApiModelProperty("任务优先级")
    private Integer priority;

    @ApiModelProperty("任务执行时长")
    private Long duration;

    @ApiModelProperty("任务删除原因")
    private String deleteReason;

    public static List<HistoricTaskVO> merge(List<HistoricTaskInstance> tasks) {
        return tasks.stream()
                .map(HistoricTaskVO::merge)
                .collect(Collectors.toList());
    }

    public static HistoricTaskVO merge(HistoricTaskInstance task) {
        HistoricTaskVO vo = new HistoricTaskVO();
        vo.setTaskId(task.getId());
        vo.setTaskName(task.getName());
        vo.setTaskDescription(task.getDescription());
        vo.setTaskDefinitionKey(task.getTaskDefinitionKey());
        vo.setAssignee(task.getAssignee());
        vo.setStartTime(task.getStartTime());
        vo.setEndTime(task.getEndTime());
        vo.setPriority(task.getPriority());
        vo.setDuration(task.getDurationInMillis());
        vo.setDeleteReason(task.getDeleteReason());
        return vo;
    }


}
