package com.zilber.boot.activiti.vo;


import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.activiti.engine.runtime.ProcessInstance;

import java.util.List;

import java.util.stream.Collectors;

@Getter
@Setter
@ApiModel("流程实例")
public class InstanceVO {

    @ApiModelProperty("是否挂起：1-正常 2-挂起")
    private Integer suspensionState;

    @ApiModelProperty("流程定义Key")
    private String procDefKey;

    @ApiModelProperty("流程定义ID")
    private String procDefId;

    @ApiModelProperty("流程实例ID")
    private String procInstId;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("发起人")
    private String createBy;

    public static List<InstanceVO> merge(List<ProcessInstance> instances) {
        return instances.stream().map(instance -> {
            InstanceVO vo = new InstanceVO();
            vo.setSuspensionState(instance.isSuspended() ? 2 : 1);
            vo.setProcDefKey(instance.getProcessDefinitionKey());
            vo.setProcDefId(instance.getProcessDefinitionId());
            vo.setProcInstId(instance.getProcessInstanceId());
            vo.setCreateBy(instance.getStartUserId());
            return vo;
        }).collect(Collectors.toList());
    }
}
