package com.zilber.boot.activiti.vo;


import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import org.activiti.engine.task.Task;
import org.springframework.beans.BeanUtils;

import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Getter
@Setter
@ApiModel("流程任务")
public class TaskVO {

    @ApiModelProperty("任务ID")
    private String taskId;

    @ApiModelProperty("任务名称")
    private String taskName;

    @ApiModelProperty("任务描述")
    private String taskDescription;

    @ApiModelProperty("任务定义Key")
    private String taskDefinitionKey;

    @ApiModelProperty("执行人")
    private String assignee;

    @ApiModelProperty("任务开始时间")
    private Date taskTime;

    @ApiModelProperty("任务优先级")
    private Integer priority;

    @ApiModelProperty("是否为挂起状态：1-否 2-是")
    private Integer suspensionState;

    public static List<TaskVO> merge(List<Task> tasks) {
        return tasks.stream().map(task -> {
            TaskVO vo = new TaskVO();
            vo.setTaskId(task.getId());
            vo.setTaskName(task.getName());
            vo.setTaskDescription(task.getDescription());
            vo.setTaskDefinitionKey(task.getTaskDefinitionKey());
            vo.setAssignee(task.getAssignee());
            vo.setTaskTime(task.getCreateTime());
            vo.setPriority(task.getPriority());
            vo.setSuspensionState(task.isSuspended() ? 2 : 1);
            return vo;
        }).collect(Collectors.toList());
    }


}
